HanMacWrdKParser Class Reference documentation

Public Member Functions | Protected Member Functions | Protected Attributes | Friends | List of all members
HanMacWrdKParser Class Reference

the main class to read a HanMac Word-K file More...

`#include <HanMacWrdKParser.hxx>`

Inheritance diagram for HanMacWrdKParser:

## Public Member Functions
| HanMacWrdKParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor More...
virtual | ~HanMacWrdKParser ()
| destructor More...
bool | checkHeader (MWAWHeader *header, bool strict=false)
| checks if the document header is correct (or not) More...
void | parse (librevenge::RVNGTextInterface *documentInterface)
| virtual function used to parse the input More...
Public Member Functions inherited from MWAWTextParser
virtual | ~MWAWTextParser ()
| destructor More...
Public Member Functions inherited from MWAWParser
virtual | ~MWAWParser ()
| virtual destructor More...
int | version () const
| returns the works version More...
MWAWParserStatePtr | getParserState ()
| returns the parser state More...
MWAWHeader * | getHeader ()
| returns the header More...
MWAWInputStreamPtr & | getInput ()
| returns the actual input More...
MWAWListenerPtr | getMainListener ()
| returns the main listener More...
MWAWGraphicListenerPtr & | getGraphicListener ()
| returns the graphic listener More...
MWAWPresentationListenerPtr & | getPresentationListener ()
| returns the presentation listener More...
MWAWSpreadsheetListenerPtr & | getSpreadsheetListener ()
| returns the spreadsheet listener More...
MWAWTextListenerPtr & | getTextListener ()
| returns the text listener More...
MWAWFontConverterPtr & | getFontConverter ()
| returns the font converter More...
MWAWFontManagerPtr & | getFontManager ()
| returns the font manager More...
MWAWPageSpan const & | getPageSpan () const
| returns the actual page dimension More...
MWAWPageSpan & | getPageSpan ()
| returns the actual page dimension More...
double | getFormLength () const
| returns the form length More...
double | getFormWidth () const
| returns the form width More...
double | getPageLength () const
| returns the page length (form length without margin ) More...
double | getPageWidth () const
| returns the page width (form width without margin ) More...
MWAWRSRCParserPtr & | getRSRCParser ()
| returns the rsrc parser More...
libmwaw::DebugFile & | ascii ()
| a DebugFile used to write what we recognize when we parse the document More...

## Protected Member Functions
void | init ()
| inits all internal variables More...
void | createDocument (librevenge::RVNGTextInterface *documentInterface)
| creates the listener which will be associated to the document More...
bool | createZones ()
| finds the different objects zones More...
MWAWVec2f | getPageLeftTop () const
| returns the page left top point ( in inches) More...
void | newPage (int number)
| adds a new page More...
bool | sendText (long id, long subId, MWAWListenerPtr listener=MWAWListenerPtr())
| send a text zone More...
bool | canSendTextAsGraphic (long id, long subId)
| check if we can send a textzone as graphic More...
bool | sendZone (long zId)
| send a zone More...
bool | getColor (int colId, int patternId, MWAWColor &color) const
| returns the color associated with a pattern More...
bool | readZonesList ()
| try to read the zones list More...
bool | readZone (shared_ptr< HanMacWrdKZone > zone)
| try to read a generic zone More...
shared_ptr< HanMacWrdKZone > | decodeZone (shared_ptr< HanMacWrdKZone > zone)
| try to decode a zone More...
bool | readFramesUnkn (shared_ptr< HanMacWrdKZone > zone)
| try to read a zone storing a list of ?, frameType More...
bool | readPrintInfo (HanMacWrdKZone &zone)
| try to read a printinfo zone (type 7) More...
bool | readZone6 (shared_ptr< HanMacWrdKZone > zone)
| try to read a unknown zone of type 6 More...
bool | readZone8 (shared_ptr< HanMacWrdKZone > zone)
| try to read a unknown zone of type 8 More...
bool | readZonea (shared_ptr< HanMacWrdKZone > zone)
| try to read a unknown zone of type a More...
bool | readZoneb (HanMacWrdKZone &zone)
| try to read a unknown zone of type b More...
bool | readZonec (shared_ptr< HanMacWrdKZone > zone)
| try to read a unknown zone of type c More...
Protected Member Functions inherited from MWAWTextParser
| MWAWTextParser (MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWTextParser (MWAWParserStatePtr state)
| constructor using a state More...
Protected Member Functions inherited from MWAWParser
| MWAWParser (MWAWParserState::Type type, MWAWInputStreamPtr input, MWAWRSRCParserPtr rsrcParser, MWAWHeader *header)
| constructor (protected) More...
| MWAWParser (MWAWParserStatePtr state)
| constructor using a state More...
void | setVersion (int vers)
| sets the document's version More...
void | setGraphicListener (MWAWGraphicListenerPtr &listener)
| sets the graphic listener More...
void | resetGraphicListener ()
| resets the listener More...
void | setPresentationListener (MWAWPresentationListenerPtr &listener)
| sets the presentation listener More...
void | resetPresentationListener ()
| resets the listener More...
void | setSpreadsheetListener (MWAWSpreadsheetListenerPtr &listener)
| sets the spreadsheet listener More...
void | resetSpreadsheetListener ()
| resets the listener More...
void | setTextListener (MWAWTextListenerPtr &listener)
| sets the text listener More...
void | resetTextListener ()
| resets the listener More...
void | setAsciiName (char const *name)
| Debugging: change the default ascii file. More...
std::string const & | asciiName () const
| return the ascii file name More...

## Protected Attributes
shared_ptr< HanMacWrdKParserInternal::State > | m_state
| the state More...
shared_ptr< HanMacWrdKGraph > | m_graphParser
| the graph parser More...
shared_ptr< HanMacWrdKText > | m_textParser
| the text parser More...

## Friends
class | HanMacWrdKGraph
class | HanMacWrdKText
class | HanMacWrdKParserInternal::SubDocument

## Detailed Description

the main class to read a HanMac Word-K file

## Constructor & Destructor Documentation

## ◆ HanMacWrdKParser()

HanMacWrdKParser::HanMacWrdKParser | ( | MWAWInputStreamPtr | input,
|  | MWAWRSRCParserPtr | rsrcParser,
|  | MWAWHeader * | header
| ) |  |

constructor

## ◆ ~HanMacWrdKParser()

HanMacWrdKParser::~HanMacWrdKParser | ( |  | ) |
| virtual

destructor

## Member Function Documentation

## ◆ canSendTextAsGraphic()

bool HanMacWrdKParser::canSendTextAsGraphic | ( | long | id,
|  | long | subId
| ) |  |
| protected

check if we can send a textzone as graphic

Referenced by HanMacWrdKGraph::canCreateGraphic(), HanMacWrdKGraph::sendFrame(), and HanMacWrdKGraph::sendGroupChild().

## ◆ checkHeader()

bool HanMacWrdKParser::checkHeader | ( | MWAWHeader * | header,
|  | bool | strict = `false`
| ) |  |
| virtual

checks if the document header is correct (or not)

Implements MWAWParser.

Referenced by parse().

## ◆ createDocument()

void HanMacWrdKParser::createDocument | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| protected

creates the listener which will be associated to the document

Referenced by parse().

## ◆ createZones()

bool HanMacWrdKParser::createZones | ( |  | ) |
| protected

finds the different objects zones

Referenced by parse().

## ◆ decodeZone()

shared_ptr< HanMacWrdKZone > HanMacWrdKParser::decodeZone | ( | shared_ptr< HanMacWrdKZone > | zone | ) |
| protected

try to decode a zone

Referenced by readZone().

## ◆ getColor()

bool HanMacWrdKParser::getColor | ( | int | colId,
|  | int | patternId,
|  | MWAWColor & | color
| ) |  | const
| protected

returns the color associated with a pattern

Referenced by HanMacWrdKText::readFont(), and HanMacWrdKText::readParagraph().

## ◆ getPageLeftTop()

MWAWVec2f HanMacWrdKParser::getPageLeftTop | ( |  | ) | const
| protected

returns the page left top point ( in inches)

## ◆ init()

void HanMacWrdKParser::init | ( |  | ) |
| protected

inits all internal variables

Referenced by HanMacWrdKParser().

## ◆ newPage()

void HanMacWrdKParser::newPage | ( | int | number | ) |
| protected

adds a new page

Referenced by HanMacWrdKText::sendText().

## ◆ parse()

void HanMacWrdKParser::parse | ( | librevenge::RVNGTextInterface * | documentInterface | ) |
| virtual

virtual function used to parse the input

Implements MWAWTextParser.

## ◆ readFramesUnkn()

bool HanMacWrdKParser::readFramesUnkn | ( | shared_ptr< HanMacWrdKZone > | zone | ) |
| protected

try to read a zone storing a list of ?, frameType

Referenced by readZone().

## ◆ readPrintInfo()

bool HanMacWrdKParser::readPrintInfo | ( | HanMacWrdKZone & | zone | ) |
| protected

try to read a printinfo zone (type 7)

Referenced by readZone().

## ◆ readZone()

bool HanMacWrdKParser::readZone | ( | shared_ptr< HanMacWrdKZone > | zone | ) |
| protected

try to read a generic zone

type1: text, type7: printInfo: typed: graphic

Referenced by createZones().

## ◆ readZone6()

bool HanMacWrdKParser::readZone6 | ( | shared_ptr< HanMacWrdKZone > | zone | ) |
| protected

try to read a unknown zone of type 6

Referenced by readZone().

## ◆ readZone8()

bool HanMacWrdKParser::readZone8 | ( | shared_ptr< HanMacWrdKZone > | zone | ) |
| protected

try to read a unknown zone of type 8

Referenced by readZone().

## ◆ readZonea()

bool HanMacWrdKParser::readZonea | ( | shared_ptr< HanMacWrdKZone > | zone | ) |
| protected

try to read a unknown zone of type a

Referenced by readZone().

## ◆ readZoneb()

bool HanMacWrdKParser::readZoneb | ( | HanMacWrdKZone & | zone | ) |
| protected

try to read a unknown zone of type b

Referenced by readZone().

## ◆ readZonec()

bool HanMacWrdKParser::readZonec | ( | shared_ptr< HanMacWrdKZone > | zone | ) |
| protected

try to read a unknown zone of type c

Referenced by readZone().

## ◆ readZonesList()

bool HanMacWrdKParser::readZonesList | ( |  | ) |
| protected

try to read the zones list

Referenced by createZones().

## ◆ sendText()

bool HanMacWrdKParser::sendText | ( | long | id,
|  | long | subId,
|  | MWAWListenerPtr | listener = `MWAWListenerPtr()`
| ) |  |
| protected

send a text zone

Referenced by HanMacWrdKParserInternal::SubDocument::parse(), and HanMacWrdKGraph::sendText().

## ◆ sendZone()

bool HanMacWrdKParser::sendZone | ( | long | zId | ) |
| protected

send a zone

Referenced by HanMacWrdKText::sendText().

## Friends And Related Function Documentation

## ◆ HanMacWrdKGraph

friend class HanMacWrdKGraph
| friend

Referenced by init().

## ◆ HanMacWrdKParserInternal::SubDocument

friend class HanMacWrdKParserInternal::SubDocument
| friend

## ◆ HanMacWrdKText

friend class HanMacWrdKText
| friend

Referenced by init().

## Member Data Documentation

## ◆ m_graphParser

shared_ptr<HanMacWrdKGraph> HanMacWrdKParser::m_graphParser
| protected

the graph parser

Referenced by createDocument(), createZones(), getColor(), init(), parse(), readZone(), and sendZone().

## ◆ m_state

shared_ptr<HanMacWrdKParserInternal::State> HanMacWrdKParser::m_state
| protected

the state

Referenced by checkHeader(), createDocument(), createZones(), getPageLeftTop(), init(), newPage(), and readZonesList().

## ◆ m_textParser

shared_ptr<HanMacWrdKText> HanMacWrdKParser::m_textParser
| protected

the text parser

Referenced by canSendTextAsGraphic(), createDocument(), createZones(), init(), parse(), readZone(), and sendText().

The documentation for this class was generated from the following files:

- HanMacWrdKParser.hxx
- HanMacWrdKParser.cxx